// Requires kotlin to be installed
// https://kotlinlang.org/docs/tutorials/command-line.html
// Can be run by "$ kotlin -script create-bundle.kts"

import java.io.*
import java.lang.StringBuilder
import java.net.*
import java.nio.file.*
import java.util.concurrent.*
import java.util.stream.*

main(args)

fun main(args: Array<String>) {
    val (srcDirs, files, excludeFiles, directoriesAndPrefixForSymbols, prefixesForSymbols, outFile) = Args.parseArgs(args)

    val allIncludableSources = srcDirs
            .flatMap { directory -> Sources.findSourceFilesInIncludedDirectory(directory, excludeFiles) }
            .plus(files.map { (path, shoudBeIncludedAs) ->
                Sources.IncludableSourceFile(shoudBeIncludedAs, path, File(path).readText(Charsets.UTF_8))
            })
            .associateBy(Sources.IncludableSourceFile::shouldBeIncludedAs)


    val merged = Sources.Merged.mergeSources(allIncludableSources)
    if (merged.notFoundIncludedFiles.isNotEmpty()) {
        println("\n*WARN* These files was not found:\n${merged.notFoundIncludedFiles.joinToString("\n") { " - " + it }}\n")
    }

    val mergedSource = "/** Generated by 'create-bundle.kts' */\n\n" + merged.source


    val resultSource = Prefixes.prefixSymbols(mergedSource, directoriesAndPrefixForSymbols, prefixesForSymbols)


    val output = File(outFile)
    File(output.parent).mkdirs()
    output.writeText(resultSource, Charsets.UTF_8)
    println("Written to ${output.path}")
}


object Sources {
    data class IncludableSourceFile(val shouldBeIncludedAs: String, val path: String, val source: String)

    fun findSourceFilesInIncludedDirectory(derectoryPath: String) =
            findSourceFilesInIncludedDirectory(derectoryPath, emptyList())

    fun findSourceFilesInIncludedDirectory(
            derectoryPath: String,
            excludeFiles: Collection<String>
    ): Collection<IncludableSourceFile> =
            Files.walk(Paths.get(derectoryPath)).iterator().asSequence()
                    .filter { path -> Files.isRegularFile(path) }
                    .map(Path::toString)
                    .filter { pathStr -> !excludeFiles.contains(pathStr) }
                    .filter { pathStr -> pathStr.endsWith(".c") || pathStr.toString().endsWith(".h") }
                    .map { pathStr -> IncludableSourceFile(
                            pathStr.replaceFirst("^${derectoryPath}/".toRegex(), ""),
                            pathStr,
                            File(pathStr).readText(Charsets.UTF_8)
                    )}
                    .toList()

    object Includes {
        data class IncludeDirective(val includesPath: String, val parsedCode: String)

        fun findIncludes(source: String) = "^\\s*#include [\"<](.+)[\">]".toRegex(RegexOption.MULTILINE)
                .findAll(source)
                .map { matched -> IncludeDirective(matched.groupValues[1], matched.value) }
                .toList()

        fun removeInclude(source: String, include: IncludeDirective) = source.replace(
                "^\\s*${include.parsedCode}".toRegex(RegexOption.MULTILINE),
                "\n/** ${include.parsedCode} removed */\n"
        )

        fun insertCodeInsteadOf(source: String, include: IncludeDirective, codeToInsert: String) = source.replace(
                "^\\s*${include.parsedCode}".toRegex(RegexOption.MULTILINE),
                "\n/** ${include.parsedCode} expanded with it's source */\n\n${codeToInsert.replace("\\", "\\\\")}"
        )
    }

    object Merged {
        data class MergedSource(
                val source: String,
                val mergedSources: Collection<IncludableSourceFile>,
                val notFoundIncludedFiles: Collection<String>
        )

        fun mergeSources(sources: Map<String, IncludableSourceFile>): MergedSource {
            val resultSource = StringBuilder()
            var alreadyIncluded: Set<IncludableSourceFile> = HashSet()
            var notFoundIncludedFiles: Set<String> = HashSet()

            val bundleSources = sources.values.find { source -> "(.*/)?_bundle\\.h".toRegex().matches(source.path) }
                    ?.let { listOf(it) }
                    ?: emptyList()

            for (sourceFile in (bundleSources + sources.values)) {
                if (alreadyIncluded.contains(sourceFile)) {
                    continue
                }

                val merged = expandIncludesWithSources(sourceFile, sources, alreadyIncluded)

                resultSource
                        .appendln("/** ${sourceFile.path} */").appendln()
                        .appendln(merged.source)
                        .appendln()
                alreadyIncluded = alreadyIncluded + merged.mergedSources
                notFoundIncludedFiles = notFoundIncludedFiles + merged.notFoundIncludedFiles
            }

            return Sources.Merged.MergedSource(resultSource.toString(), alreadyIncluded, notFoundIncludedFiles)
        }

        private fun expandIncludesWithSources(
                sourceFile: IncludableSourceFile,
                includableSourceFiles: Map<String, IncludableSourceFile>,
                sourceFilesToIgnore: Set<IncludableSourceFile>
        ): MergedSource {

            var resultSource = sourceFile.source
            val notFound: MutableSet<String> = HashSet()
            val mergedSources: MutableSet<IncludableSourceFile> = HashSet()

            mergedSources.add(sourceFile)

            Includes.findIncludes(sourceFile.source).forEach { include ->
                val includeRelativePath = URI.create(sourceFile.shouldBeIncludedAs)
                        .resolve(include.includesPath)
                        .toString()

                val includePath = when {
                    includableSourceFiles.containsKey(includeRelativePath) -> includeRelativePath
                    includableSourceFiles.containsKey(include.includesPath) -> include.includesPath
                    else -> null
                }

                val fileToInclude = includableSourceFiles[includePath]

                if (fileToInclude != null) {
                    if (sourceFilesToIgnore.contains(fileToInclude) || mergedSources.contains(fileToInclude)) {
                        resultSource = Includes.removeInclude(resultSource, include)
                    } else {
                        val mergedSourceFileToInclude = expandIncludesWithSources(
                                fileToInclude,
                                includableSourceFiles,
                                sourceFilesToIgnore + mergedSources
                        )

                        mergedSources.addAll(mergedSourceFileToInclude.mergedSources)
                        notFound.addAll(mergedSourceFileToInclude.notFoundIncludedFiles)

                        resultSource = Includes.insertCodeInsteadOf(
                                resultSource,
                                include,
                                mergedSourceFileToInclude.source
                        )
                    }
                } else {
                    notFound.add(include.includesPath)
                }
            }

            return MergedSource(resultSource, mergedSources, notFound)
        }
    }
}


object Prefixes {

    fun prefixSymbols(
            source: String,
            directoriesAndPrefixForSymbols: Map<String, String>,
            symbolsAndPrefixes: Map<String, String>
    ): String {
        var resultSource = source

        for (direactoryAndPrefix in directoriesAndPrefixForSymbols) {
            val sources = Sources.findSourceFilesInIncludedDirectory(direactoryAndPrefix.key)
            val prefix = direactoryAndPrefix.value

            println("Using prefix '${prefix}' for symbols of source files from direcotry '${direactoryAndPrefix.key}'\n")

            val symbols = sources
                    .flatMap(Prefixes::findSymbols)
                    .toSet()

            for (symbol in symbols) {
//                println(symbol)
                resultSource = resultSource.replace("${symbol}(?![-_\\w\\d])".toRegex(), "${prefix}_${symbol}")
            }
        }

        for (symbolAndPrefix in symbolsAndPrefixes) {
            val symbol = symbolAndPrefix.key
            val prefix = symbolAndPrefix.value

            resultSource = resultSource.replace("${symbol}(?![-_\\w\\d])".toRegex(), "${prefix}_${symbol}")
        }

        return resultSource
    }

    private fun findSymbols(sourceFile: Sources.IncludableSourceFile): Set<String> {
        val defines = Pair("#define ([^\\s(]+)", 1)
        val structs = Pair("^[^/*]*?struct ([\\w\\d-_]+) (?=[{])?", 1)
        val typedefs = Pair("^[^/*]*?typedef (struct )?\\S+ (\\S+)(?=;)", 2)

        val symbolsFromRegex = arrayOf(defines, structs, typedefs)
                .flatMap { regexAndGroupNumber ->
                    regexAndGroupNumber.first.toRegex(RegexOption.MULTILINE)
                            .findAll(sourceFile.source)
                            .map { it.groupValues[regexAndGroupNumber.second] }
                            .toList()
                }

        val functions: Set<String> = if (sourceFile.path.endsWith(".c"))
            findSymbolsByNmOutput(sourceFile)
        else
            emptySet()

        return (symbolsFromRegex + functions).toSet()
    }

    private fun findSymbolsByNmOutput(source: Sources.IncludableSourceFile): Set<String> {
        val process = ProcessBuilder("sh", "-c",
                "mkdir -p .temp "
                        + "&& gcc -c ${source.path} -o .temp/compiled.o "
                        + "&& nm --defined-only .temp/compiled.o"
                        + "&& rm -rf .temp"
        )
                .redirectErrorStream(true)
                .start()

        process.waitFor(10, TimeUnit.SECONDS)

        return ".+?_(.*)".toRegex()
                .findAll(process.inputStream.bufferedReader().readText())
                .map { it.groupValues[1] }
                .toSet()
    }
}


object Args {
    data class ScriptArgs(
            val srcDirs: Collection<String>,
            var files: HashMap<String, String>,
            val excludeFiles: Collection<String>,

            val directoriesAndPrefixForSymbols: HashMap<String, String>,
            val prefixesForSymbols: HashMap<String, String>,

            val out: String
    )

    fun parseArgs(args: Array<String>): ScriptArgs {
        var srcDirs = ArrayList<String>()
        var files = HashMap<String, String>()
        var excludeFiles = ArrayList<String>()

        var directoriesAndPrefixForSymbols = HashMap<String, String>()
        var symbolsAndPrefixes = HashMap<String, String>()

        var outFile = "bundle.c"

        val argsIterator = args.iterator()
        while (argsIterator.hasNext()) {
            val arg = argsIterator.next()

            if (arg == "--src" || arg == "-s") {
                val srcDir = argsIterator.next()
                srcDirs.add(srcDir)
                println("Using src directory '${srcDir}'")
            }

            if (arg == "--file" || arg == "-f") {
                argsIterator.next().split(":").let {
                    files.put(it[0], it[1])
                }
            }

            if (arg == "--exclude" || arg == "-e") {
                excludeFiles.add(argsIterator.next())
            }

            if (arg == "--prefixAll") {
                argsIterator.next().split(":").let {
                    directoriesAndPrefixForSymbols.put(it[0], it[1])
                }
            }

            if (arg == "--prefix" || arg == "-p") {
                var argValue = ""
                do {
                    argValue += argsIterator.next()
                } while (!argValue.contains(":"))

                val (symbols, prefix) = argValue.split(":")
                        .let { Pair(it[0], it[1]) }

                for (symbol in symbols.split(",")) {
                    symbolsAndPrefixes.put(symbol, prefix)
                }
            }

            if (arg == "--out" || arg == "-o") {
                outFile = argsIterator.next()
            }
        }

        return ScriptArgs(srcDirs, files, excludeFiles, directoriesAndPrefixForSymbols, symbolsAndPrefixes, outFile)
    }
}
